unit use_sk_access_tcp;

{$mode objfpc}{$H+}

interface
uses
  Classes,
  Forms,
  Controls,
  StdCtrls,
  ExtCtrls,
  Messages,
  SysUtils
//  ,U_Server_Tcp,
//  sk_access_tcpST
  ;

{$I sk_access_tcp.inc}

const
  SB_THUMBTRACK = 5;
  SB_BOTTOM = 7;

type
  { TForm1 }
  TForm1 = class(TForm)
    BStart_Server: TButton;
    BStop_Server: TButton;
    BGet_IP: TButton;
    BLimpa: TButton;
    BEco: TButton;
    BClear_Disp: TButton;
    BClear_L1: TButton;
    BClear_L2: TButton;
    BCursor_On: TButton;
    BCursor_Off: TButton;
    BCursor_Blink: TButton;
    BDisp_Str: TButton;
    BLine_Feed: TButton;
    BCarriage_Return: TButton;
    BDisp_Char: TButton;
    BGotoxy: TButton;
    BGet_Status: TButton;
    BBack_Space: TButton;
    BTroca_Pagina: TButton;
    BGet_Ver: TButton;
    BGet_Firm: TButton;
    BSet_Udg: TButton;
    BGet_Cursor: TButton;
    BGet_Data: TButton;
    BReset_Inter: TButton;
    BSet_Interface: TButton;
    BTeste: TButton;
    ComboBox1: TComboBox;
    E_Version: TEdit;
    E_Interface: TEdit;
    E_Status: TEdit;
    E_X: TEdit;
    E_Y: TEdit;
    E_Char: TEdit;
    E_Port: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    L_Y: TLabel;
    L_X: TLabel;
    Memo1: TMemo;
    Timer1: TTimer;
    procedure BBack_SpaceClick(Sender: TObject);
    procedure BCarriage_ReturnClick(Sender: TObject);
    procedure BClear_DispClick(Sender: TObject);
    procedure BClear_L1Click(Sender: TObject);
    procedure BClear_L2Click(Sender: TObject);
    procedure BCursor_BlinkClick(Sender: TObject);
    procedure BCursor_OffClick(Sender: TObject);
    procedure BCursor_OnClick(Sender: TObject);
    procedure BDisp_CharClick(Sender: TObject);
    procedure BDisp_StrClick(Sender: TObject);
    procedure BEcoClick(Sender: TObject);
    procedure BGet_CursorClick(Sender: TObject);
    procedure BGet_DataClick(Sender: TObject);
    procedure BGet_FirmClick(Sender: TObject);
    procedure BGet_StatusClick(Sender: TObject);
    procedure BGet_VerClick(Sender: TObject);
    procedure BGotoxyClick(Sender: TObject);
    procedure BLimpaClick(Sender: TObject);
    procedure BLine_FeedClick(Sender: TObject);
    procedure BReset_InterClick(Sender: TObject);
    procedure BSet_InterfaceClick(Sender: TObject);
    procedure BSet_UdgClick(Sender: TObject);
    procedure BStart_ServerClick(Sender: TObject);
    procedure BStop_ServerClick(Sender: TObject);
    procedure BGet_IPClick(Sender: TObject);
    procedure BTroca_PaginaClick(Sender: TObject);
    procedure BTesteClick(Sender: TObject);
    procedure ComboBox1Select(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Memo1KeyPress(Sender: TObject; var Key: char);
    procedure Timer1Timer(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;
  current_client:integer;         //Cliente atualmente selecionado
  pagina:byte;                    //Pagina de scan codes selecionadad
  dll_ver,ip:array[0..25] of char;
  eco_status:boolean;             //Eco = ligado / desligado
  client_list:Tsockets;           //buffer p/ clientes conectados
  server_on:boolean;              //Indica servidor Ativado/desativado

implementation

{$R *.lfm}
{-------------------------------------------------------------------------------
                    Converte número inteiro em String
-------------------------------------------------------------------------------}
Function i2str(I: Uint): string;

var
  S: string[11];
begin
  Str(I, S);
  Result:= S;
end;
{-------------------------------------------------------------------------------
                      Transforma string em inteiro
-------------------------------------------------------------------------------}
Function str2i(str:string):Dword;
var
   i,code:integer;
begin
   val(str,i,code);
   str2i:=i;
end;
{-------------------------------------------------------------------------------
                              Atualiza ComboBox
-------------------------------------------------------------------------------}

Procedure Update_Combo;
var
   c,cc:byte;
   current_client_alive:boolean;
begin
   current_client_alive:=false;
   cc:=str2i(Form1.ComboBox1.text);          //cc=cliente atual selecionado
   Form1.ComboBox1.Items.Clear;              //Apaga itens ComboBox
   List_Clients(@client_list);               //Le lista de clientes conectados
   for c:=1 to 32 do                         //Adiciona Clientes conectados a lista
      if client_list.ip[c]<> 0 then begin
         if c=cc then current_client_alive:=true;
         Form1.ComboBox1.Items.Add(i2str(c))
      end;
   if not(current_client_alive) then Form1.ComboBox1.text:='' //Apaga seleção
end;
{-------------------------------------------------------------------------------
        Procedimento que recebe evento de conexão
        Wparam = IP do cliente em hexadeciaml
        LParamHi = ID do cliente
        LParamLo = 1 para conexão 0 para desconexão
-------------------------------------------------------------------------------}
Procedure Deal_CONNECT(var Msg: TMessage); cdecl;
var
   conec_msg:string[80];
begin
 with Form1 do begin
   Memo1.SetFocus;
   if Msg.LParamLo=1 then begin  //Trata conexão de cliente
      conec_msg:='Cliente '+ IntToStr(Msg.LParamHi)+' Conectou';
      memo1.lines.add(conec_msg);
      Get_Host_IP(ip);           //Le IP do servidor
      conec_msg:='Host IP='+ip;
      Set_Client(Msg.LParamHi);
      Get_Client_IP(ip);         //Le IP do Cliente que conectou
      conec_msg:=conec_msg+' -- Client IP='+ip;
      Set_Client(current_client);//Retorna foco para o cliente corrente
      memo1.lines.add(conec_msg);
   end else begin                //Trata desconexão de cliente
      conec_msg:='Cliente '+ IntToStr(Msg.LParamHi)+' Desconectou';
      memo1.lines.add(conec_msg);
      if current_client=Msg.LParamHi then begin //Se Cliente selecionado desconectou...
         current_client:=0;                     //Aponta para Cliente NULL
         Set_Interface('cl0');                  //Chama DLL
      end;
   end;
//   Memo1.Update;
//   Update;
 end;
   Update_Combo;
end;
{-------------------------------------------------------------------------------
        Procedimento que recebe evento de comunicação
        Wparam = Tipo de comunicação
        LParamHi = ID do cliente
        LParamLo = Caracter recebido
-------------------------------------------------------------------------------}
Procedure Deal_COMMUNIC(var Msg: TMessage); cdecl;
begin
 with Form1 do
   if current_client = Msg.LParamHi then begin     //Se é dado do cliente selecionado
      memo1.Text:=memo1.Text + char(Msg.WParamLo); //i2str(ord(Msg.LParamLo))+' ';
      memo1.selstart:=length(memo1.text);          //Coloca cursor no fim do texto
//      Memo1.Perform(WM_VSCROLL,SB_BOTTOM,SB_THUMBTRACK) //Mostra ultima linha
//      SendMessage(memo1.Handle, EM_SCROLLCARET, 0, 0);  //Mostra ultima linha
   end;
end;

{ TForm1 }
{-------------------------------------------------------------------------------
                   Ativa Servidor de teclados SMAK
-------------------------------------------------------------------------------}
procedure TForm1.BStart_ServerClick(Sender: TObject);
begin
   if not(server_on) then begin
      server_on:=true;
      Set_Port(str2i(E_Port.text));
      Start_Server(@Deal_CONNECT,@Deal_COMMUNIC);
      memo1.lines.add('Servidor Telnet Iniciado');
   end;
end;

{-------------------------------------------------------------------------------
                       Limpa janela principal
-------------------------------------------------------------------------------}
Procedure TForm1.BLimpaClick(Sender: TObject);
begin
   Memo1.Text:='';
end;

{-------------------------------------------------------------------------------
              Envia Line Feed para o terminal selecionado
-------------------------------------------------------------------------------}
Procedure TForm1.BLine_FeedClick(Sender: TObject);
begin
   Line_Feed;                                 //Chama DLL
end;

{-------------------------------------------------------------------------------
                      Seleciona cliente NENHUM
-------------------------------------------------------------------------------}
Procedure TForm1.BReset_InterClick(Sender: TObject);
begin
   Reset_Interface;                                     //Chama DLL
   current_client:=0;
   ComboBox1.Text:='';
end;

{-------------------------------------------------------------------------------
                  Seleciona cliente (cl1, cl2 , cl3...)
-------------------------------------------------------------------------------}
Procedure TForm1.BSet_InterfaceClick(Sender: TObject);
var
   strbuf:array[0..10] of char;
   result:integer;
begin
   result:=Set_Interface(strpcopy(strbuf,E_Interface.text)); //Chama DLL
   if result=-1 then E_Interface.text:='????';         //Se interfase indisponível
   if result>0 then E_Interface.text:=E_Interface.text+'*';  //Se SKO conectado
end;

{-------------------------------------------------------------------------------
          Define um caracter especial no cliente selecionado
-------------------------------------------------------------------------------}
Procedure TForm1.BSet_UdgClick(Sender: TObject);
var
   car:byte;
begin
   Cursor_Off;                                  //Chama DLL
   disp_char(char($0));                         //Mostra o caracter #0
   for car:=0 to 4 do begin
     Set_Udg(0,$3F,$11,$11,$3F,$11,$11,$11,$00);//Redesenha o caracter #0
     sleep(100);
     Set_Udg(0,$11,$11,$3F,$11,$11,$11,$00,$3F);//Chama DLL
     sleep(100);
     Set_Udg(0,$11,$3F,$11,$11,$11,$00,$3F,$11);
     sleep(100);
     Set_Udg(0,$3F,$11,$11,$11,$00,$3F,$11,$11);
     sleep(100);
     Set_Udg(0,$11,$11,$11,$00,$3F,$11,$11,$3F);
     sleep(100);
     Set_Udg(0,$11,$11,$00,$3F,$11,$11,$3F,$11);
     sleep(100);
     Set_Udg(0,$11,$00,$3F,$11,$11,$3F,$11,$11);
     sleep(100);
     Set_Udg(0,$00,$3F,$11,$11,$3F,$11,$11,$11);
     sleep(100);
   end;
   Cursor_Blink;                                 //Chama DLL
end;

{-------------------------------------------------------------------------------
    Liga/Desliga Eco, digitação no cliente é enviada de volta para o display
-------------------------------------------------------------------------------}
Procedure TForm1.BEcoClick(Sender: TObject);
begin
   if eco_status=false then begin
      eco_status:=true;
      Set_Eco_On;                                       //Chama DLL
      BEco.caption:='Desliga Eco';
   end else begin
      eco_status:=False;
      Set_Eco_Off;                                      //Chama DLL
      BEco.caption:='Liga Eco';
   end;
end;

{-------------------------------------------------------------------------------
              Le posição do cursor no cliente selecionado
-------------------------------------------------------------------------------}
Procedure TForm1.BGet_CursorClick(Sender: TObject);
var
  d,x,y:byte;
  s:string[11];
begin
   d:=Get_Cursor(@x,@y);  {Calcula X e Y}        //Chama DLL
   if d=$ff then E_Interface.text:='TIME-OUT'
   else begin
      str(x,s);
      E_X.text:=s; {Coordenada X 1..40}
      str(y,s);
      E_Y.text:=s; {Coordenada y 1..2}
      str(d,s);
      E_Status.text:=s; {Coordenada incremental 0..79}
   end;
end;

{-------------------------------------------------------------------------------
                    Le dados do buffer de recepção
-------------------------------------------------------------------------------}
Procedure TForm1.BGet_DataClick(Sender: TObject);
var
   buffer:array[0..10] of Tkey_def;
   c,d:byte;
begin
   c:=Get_Data(@buffer,3);    //Le no maximo 3 dados e coloca no buffer
   if c>0 then                //Se tinha dados a serem lidos
      for d:=0 to c-1 do      //Coloca em Edit4
         Memo1.text:=Memo1.text+buffer[d].scan;
end;

{-------------------------------------------------------------------------------
              Le versão do firmware do cliente selecionado
-------------------------------------------------------------------------------}
procedure TForm1.BGet_FirmClick(Sender: TObject);
begin
   Get_Firmware_Version(dll_ver);             //Chama DLL
   E_Version.text:=dll_ver;
end;

{-------------------------------------------------------------------------------
                 Le Status do terminal selecionado
-------------------------------------------------------------------------------}
Procedure TForm1.BGet_StatusClick(Sender: TObject);
var
   status:byte;
begin
   status:=Get_Status;                        //Chama DLL
   if status=0 then E_Status.text:='OK'
   else if status=1 then E_Status.text:='FALHA'
   else E_Status.text:='TIME-OUT';
end;

{-------------------------------------------------------------------------------
                            Le versão da DLL
-------------------------------------------------------------------------------}
Procedure TForm1.BGet_VerClick(Sender: TObject);
begin
   Get_Dll_Version(dll_ver);                   //Chama DLL
   E_Version.text:=dll_ver;
end;

{-------------------------------------------------------------------------------
                 Posiciona cursor no cliente selecionado
-------------------------------------------------------------------------------}
Procedure TForm1.BGotoxyClick(Sender: TObject);
var
   x,y,code:integer;
begin
   Val(E_X.text,x,code);
   if code<>0 then begin
      E_X.text:='1';
      x:=1;
   end;

   Val(E_Y.text,y,code);
   if code<>0 then begin
      E_Y.text:='1';
      y:=1;
   end;
   Gotoxy(x,y);                                  //Chama DLL
end;

{-------------------------------------------------------------------------------
                 Apaga display do terminal selecionado
-------------------------------------------------------------------------------}
Procedure TForm1.BClear_DispClick(Sender: TObject);
begin
   Clear_Disp;                                 //Chama DLL
end;

{-------------------------------------------------------------------------------
             Envia Carriage Return para o cliente selecionado
-------------------------------------------------------------------------------}
Procedure TForm1.BCarriage_ReturnClick(Sender: TObject);
begin
   Carriage_Return;                         //Chama DLL
end;

{-------------------------------------------------------------------------------
               Envia Back Space para o cliente selecionado
-------------------------------------------------------------------------------}
Procedure TForm1.BBack_SpaceClick(Sender: TObject);
begin
   Back_Space;                              //Chama DLL
end;

{-------------------------------------------------------------------------------
             Apaga primeira linha do cliente selecionado
-------------------------------------------------------------------------------}
Procedure TForm1.BClear_L1Click(Sender: TObject);
begin
   Clear_L1;                                  //Chama DLL
end;

{-------------------------------------------------------------------------------
              Apaga segunda linha do cliente selecionado
-------------------------------------------------------------------------------}
Procedure TForm1.BClear_L2Click(Sender: TObject);
begin
   Clear_L2;                                 //Chama DLL
end;
{-------------------------------------------------------------------------------
             Seleciona Cursor ligado no cliente selecionado
-------------------------------------------------------------------------------}
Procedure TForm1.BCursor_OnClick(Sender: TObject);
begin
   Cursor_On;                              //Chama DLL
end;

{-------------------------------------------------------------------------------
               Envia um caracter para o display do teclado
-------------------------------------------------------------------------------}
Procedure TForm1.BDisp_CharClick(Sender: TObject);
begin
   Disp_Char(E_Char.text[1]);                            //Chama DLL
end;

{-------------------------------------------------------------------------------
            Mostra 1st linha de MEMO1 no clente selecionado
-------------------------------------------------------------------------------}
procedure TForm1.BDisp_StrClick(Sender: TObject);
var
   strbuf:array[0..81] of char;
begin
   Disp(strpcopy(strbuf,Memo1.Lines[0]));     //Chama DLL
end;

{-------------------------------------------------------------------------------
           Seleciona Cursor desligado no cliente selecionado
-------------------------------------------------------------------------------}
Procedure TForm1.BCursor_OffClick(Sender: TObject);
begin
   Cursor_Off;                             //Chama DLL
end;
{-------------------------------------------------------------------------------
           Seleciona Cursor piscando no cliente selecionado
-------------------------------------------------------------------------------}
Procedure TForm1.BCursor_BlinkClick(Sender: TObject);
begin
   Cursor_Blink;                          //Chama DLL
end;
{-------------------------------------------------------------------------------
                   Desativa Servidor de teclados SMAK
-------------------------------------------------------------------------------}
Procedure TForm1.BStop_ServerClick(Sender: TObject);
begin
   if server_on then begin
      server_on:=false;
      Kill_Server;                                   //Chama DLL
      memo1.lines.add('Servidor Telnet Finalizado');
   end;
end;

procedure TForm1.BGet_IPClick(Sender: TObject);
var
   buffer : array[0..100] of char;
begin
  Get_Host_IP(buffer);
  E_Status.Text:=buffer;
end;

{-------------------------------------------------------------------------------
            Troca pagina de scan-codes no cliente selecionado
-------------------------------------------------------------------------------}
Procedure TForm1.BTroca_PaginaClick(Sender: TObject);
begin
   if pagina=0 then begin
      pagina:=$01;
      Set_Page1;                           //Chama DLL
   end else begin
      pagina:=$00;
      Set_Page0;                           //Chama DLL
   end;
end;

procedure TForm1.BTesteClick(Sender: TObject);
begin
  ProccessMessages;
end;

{-------------------------------------------------------------------------------
             Seleciona cliente conforme seleção da COMBO-BOX
-------------------------------------------------------------------------------}
Procedure TForm1.ComboBox1Select(Sender: TObject);
var
   resp:integer;
//   ip:string[17];
begin
   current_client:=str2i(ComboBox1.text);

//   resp:=Get_Same_Ip(current_client);
//   if resp<>0 then memo1.lines.add('Client parceiro='+i2str(resp))
//   else memo1.lines.add('Nao tem cliente parceiro');

//   resp:=Get_Client_Type(current_client);
//   if resp=-1 then memo1.lines.add('Cliente indisponivel');
//   if resp=0 then memo1.lines.add('Cliente '+i2str(current_client)+' é Slave');
//   if resp=1 then memo1.lines.add('Cliente '+i2str(current_client)+' é Master');

   resp:=Set_MClient(current_client);
   if resp=-1 then memo1.lines.add('Cliente indisponivel');
   if resp=0 then memo1.lines.add('Cliente é slave nao tem master');
   if resp>0 then memo1.lines.add('Cliente master='+i2str(resp));

   resp:=Set_SClient(current_client);
   if resp=-1 then memo1.lines.add('Cliente indisponivel');
   if resp=0 then memo1.lines.add('Cliente é master nao tem slave');
   if resp>0 then memo1.lines.add('Cliente Slave='+i2str(resp));

   resp:=Set_Client(current_client);
   if resp=-1 then memo1.lines.add('Cliente indisponivel');

//   Form1.ComboBox1.Items.Clear;
//   List_Clients(@client_list);
//   ip:=ip_hex2ascii(client_list.ip[1]);
//   showmessage(ip+' '+ip2);
end;

Procedure TForm1.FormDestroy(Sender: TObject);
begin
  Free_Sk_Access;
end;

{-------------------------------------------------------------------------------
    Trata eventos de digitação em Memo1, enviandos os caracteres para o terminal
selecionado
-------------------------------------------------------------------------------}
Procedure TForm1.Memo1KeyPress(Sender: TObject; var Key: Char);
begin
   if current_client <> 0 then begin
      Disp_Char(key);                                //Chama DLL
      if key = char($0d) then Disp_Char(char($0A));
   end;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  ProccessMessages;
end;

end.

